## RygelTranscoder RygelTranscoder — The base Transcoder class. Each implementation derives from it and must implement `create_source()` and `get_distance()`. |

## Functions

#define | RYGEL_TYPE_TRANSCODER
RygelDataSource * | rygel_transcoder_create_source ()
GUPnPDIDLLiteResource * | rygel_transcoder_add_resource ()
gboolean | rygel_transcoder_can_handle ()
guint | rygel_transcoder_get_distance ()
gboolean | rygel_transcoder_mime_type_is_a ()
const gchar * | rygel_transcoder_get_mime_type ()
const gchar * | rygel_transcoder_get_dlna_profile ()
const gchar * | rygel_transcoder_get_extension ()

## Properties

gchar * | dlna-profile | Read / Write / Construct Only
gchar * | extension | Read / Write / Construct Only
gchar * | mime-type | Read / Write / Construct Only

## Types and Values

struct | RygelTranscoder
struct | RygelTranscoderClass

## Object Hierarchy

        GObject
        ╰── RygelTranscoder

## Description

Transcoders are obtained from `rygel_media_engine_get_transcoders()` and are only expected to support the derived RygelDataSource types provided by the same media engine.

## Functions

### RYGEL_TYPE_TRANSCODER

    #define RYGEL_TYPE_TRANSCODER (rygel_transcoder_get_type ())

The type for RygelTranscoder.

### rygel_transcoder_create_source ()

    RygelDataSource *
    rygel_transcoder_create_source (RygelTranscoder *self,
                                    RygelMediaItem *item,
                                    RygelDataSource *src,
                                    GError **error);

Creates a transcoding source.

The provided original RygelDataSource will have been implemented by the same media engine that provided the RygelTranscoder, allowing the RygelTranscoder to access specific resources of the underlying multimedia backend used by the media engine.

#### Parameters

self | the RygelTranscoder instance |
src | . the media item to create the transcoding source for. | [in]
src | . the original (non-transcoding) source. | [in]
item |  |
error | location to store the error occuring, or `NULL` to ignore |

#### Returns

the new transcoding source

### rygel_transcoder_add_resource ()

    GUPnPDIDLLiteResource *
    rygel_transcoder_add_resource (RygelTranscoder *self,
                                   GUPnPDIDLLiteItem *didl_item,
                                   RygelMediaItem *item,
                                   RygelTranscodeManager *manager,
                                   GError **error);

Derived classes should implement this function to fill a GUPnPDIDLLiteResource, representing the transcoded content, with parameters specific to the transcoder, such as bitrate or resolution. The GUPnPDIDLLiteResource should be instantiated by calling this base class implementation, passing the provided didl_item, item and manager parameters.

#### Parameters

self | the RygelTranscoder instance |
didl_item | . The DIDLLite item for which to create the resource, by calling the base class implementation. | [in]
item | . The media item for which to create the DIDLiteResource, by calling the base class implementation. | [in]
manager | . The transcoder manager to pass to the base class implemenetation. | [in]
error | location to store the error occuring, or `NULL` to ignore |

#### Returns

The new resource.

### rygel_transcoder_can_handle ()

    gboolean
    rygel_transcoder_can_handle (RygelTranscoder *self,
                                 const gchar *target);

Returns whether this trancoder can handle the specified DLNA profile. This is determined by the RygelTranscodeManager, which checks the suitability of each RygelTranscoder by calling `rygel_transcoder_get_distance()` with each RygelMediaItem, choosing one DLNA profile for each transcoder to handle.

#### Parameters

self | the RygelTranscoder instance |
target | . A DLNA profile name as obtained from `rygel_media_item_get_dlna_profile()`. | [in]

#### Returns

True if the transcoder can handle the specified DLNA profile.

### rygel_transcoder_get_distance ()

    guint
    rygel_transcoder_get_distance (RygelTranscoder *self,
                                   RygelMediaItem *item);

Gets a numeric value that gives an gives an estimate of how hard it would be for this transcoder to trancode `item` to the target profile of this transcoder.

#### Parameters

self | the RygelTranscoder instance |
item | . the media item to calculate the distance for. | [in]

#### Returns

the distance from the `item` , uint.MIN if providing such a value is impossible or uint.MAX if it doesn't make any sense to use this transcoder for `item`

### rygel_transcoder_mime_type_is_a ()

    gboolean
    rygel_transcoder_mime_type_is_a (RygelTranscoder *self,
                                     const gchar *mime_type1,
                                     const gchar *mime_type2);

#### Parameters

self | the RygelTranscoder instance |
mime_type1 |  |
mime_type2 |  |

### rygel_transcoder_get_mime_type ()

    const gchar *
    rygel_transcoder_get_mime_type (RygelTranscoder *self);

Get and return the current value of the "mime-type" property.

#### Parameters

self | the RygelTranscoder instance to query |

#### Returns

the value of the "mime-type" property

### rygel_transcoder_get_dlna_profile ()

    const gchar *
    rygel_transcoder_get_dlna_profile (RygelTranscoder *self);

Get and return the current value of the "dlna-profile" property.

#### Parameters

self | the RygelTranscoder instance to query |

#### Returns

the value of the "dlna-profile" property

### rygel_transcoder_get_extension ()

    const gchar *
    rygel_transcoder_get_extension (RygelTranscoder *self);

Get and return the current value of the "extension" property.

#### Parameters

self | the RygelTranscoder instance to query |

#### Returns

the value of the "extension" property

## Types and Values

### struct RygelTranscoder

    struct RygelTranscoder;

The base Transcoder class. Each implementation derives from it and must implement `create_source()` and `get_distance()`.

Transcoders are obtained from `rygel_media_engine_get_transcoders()` and are only expected to support the derived RygelDataSource types provided by the same media engine.

### struct RygelTranscoderClass

    struct RygelTranscoderClass {
    	GObjectClass parent_class;
    	RygelDataSource* (*create_source) (RygelTranscoder* self, RygelMediaItem* item, RygelDataSource* src, GError** error);
    	GUPnPDIDLLiteResource* (*add_resource) (RygelTranscoder* self, GUPnPDIDLLiteItem* didl_item, RygelMediaItem* item, RygelTranscodeManager* manager, GError** error);
    	guint (*get_distance) (RygelTranscoder* self, RygelMediaItem* item);
    };

The class structure for `RYGEL_TYPE_TRANSCODER`. All the fields in this structure are private and should never be accessed directly.

#### Members

GObjectClass `parent_class`; | the parent class structure |
`create_source` () | virtual method called by `rygel_transcoder_create_source()` |
`add_resource` () | virtual method called by `rygel_transcoder_add_resource()` |
`get_distance` () | virtual method called by `rygel_transcoder_get_distance()` |

## Property Details

### The `“dlna-profile”` property

      “dlna-profile”             gchar *

dlna-profile.

Flags: Read / Write / Construct Only

Default value: NULL

### The `“extension”` property

      “extension”                gchar *

extension.

Flags: Read / Write / Construct Only

Default value: NULL

### The `“mime-type”` property

      “mime-type”                gchar *

mime-type.

Flags: Read / Write / Construct Only

Default value: NULL